#pragma semicolon 1

#include <sourcemod>
#include <cstrike>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [ReSpawn]",
	author	= "wS",
	version = "1.2.5"
};

#define ITEM_NAME "respawn"
#define ITEM_NAME_AUTORESPAWN "autorespawn"

new g_bAccess[MAXPLAYERS + 1];			// доступно возрождений за раунд
new bool:g_bAutoRespawn[MAXPLAYERS + 1];
new Handle:g_hTimer[MAXPLAYERS + 1];
new String:g_sKey[MAXPLAYERS + 1][20];	// STEAM_x:x:key
new Handle:g_hTrie;						// key => respawns
new Handle:g_hCvarRespawnTime;
new g_RespawnStopTimestamp;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	g_hCvarRespawnTime = CreateConVar("respawn_time", "60", "Запретить возрождение, если до конца раунда осталось 'x' сек или меньше (0 = откл)");
	AutoExecConfig(true, ITEM_NAME, "vip/modules/respawn");

	g_hTrie = CreateTrie();

	LoadTranslations("vip_respawn.phrases");
	RegConsoleCmd("sm_respawn",					RespawnCmd);

	HookEvent("round_end",		round_end,		EventHookMode_PostNoCopy);
	HookEvent("round_start",	round_start,	EventHookMode_Post);
	HookEvent("player_death",	event_respawn,	EventHookMode_Post);
	HookEvent("player_team",	event_respawn,	EventHookMode_Post);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client]) 
	{
		FormatEx(ItemValue, ItemValueSize, "%d,%d", g_bAccess[client], RespawnsLeft(client));
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
							
	new value = StringToInt(ItemValue);
	if (value < 1)
		return VGA_BadValue;
	
	if (value > 99999)
		value = 99999;
	
	if (value == g_bAccess[client])
		return VGA_SameValue;
	
	if (!g_sKey[client][0])
	{
		decl String:steamid[STEAMID_LENGTH];
		if (!GetClientAuthId(client, AuthId_Steam2, steamid, STEAMID_LENGTH))
			return VGA_Stop;

		new index = FindCharInString(steamid, ':', true);
		if (index < 0)
			return VGA_Stop;
		
		strcopy(g_sKey[client], sizeof(g_sKey[]), steamid[index + 1]); // STEAM_x:x:key
	}
	
	if (!g_bAutoRespawn[client] && !g_bAccess[client] && kv)
	{
		KvRewind(kv);
		g_bAutoRespawn[client] = KvGetNum(kv, ITEM_NAME_AUTORESPAWN) == 1;
	}
	
	g_bAccess[client] = value;
	wS_TryAutoReSpawn(client, true);
	
	FormatEx(ItemValue, ITEM_INFO_LENGTH, "%d,%d", g_bAccess[client], RespawnsLeft(client));
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, ItemValue, ITEM_INFO_LENGTH);
	
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	ClearAccessVars(client);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
}

///////////////////////////////////////////////////////////////////////////////////

public VIP_MenuSelect(client, ItemID)
{
	MyPanel(client);
}

stock MyPanel(client)
{
	new Handle:panel = CreatePanel();
	decl String:sText[512];
	
	FormatEx(sText, sizeof(sText), "%T\n \n", "info", client, g_bAccess[client], RespawnsLeft(client));
	DrawPanelText(panel, sText);
	
	FormatEx(sText, sizeof(sText), "%T\n \n", g_bAutoRespawn[client] ? "+" : "-", client);
	SetPanelCurrentKey(panel, 5);
	DrawPanelItem(panel, sText);
	
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	
	FormatEx(sText, sizeof(sText), "%T", "exit", client);
	SetPanelCurrentKey(panel, GetEngineVersion() == Engine_CSGO ? 9 : 10);
	DrawPanelItem(panel, sText);
	
	SendPanelToClient(panel, client, MyPanel_CallBack, 0);
	CloseHandle(panel);
}

public MyPanel_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action != MenuAction_Select || VIP_MenuFlood(client))
		return;
	
	if (item == 5)
	{
		PLAY_SELECT_SOUND(client);
		
		new bool:bAccessByFlag;
		if (!VIP_HaveAccessToItem(client, VIP_GetItemID(ITEM_NAME), bAccessByFlag))
		{
			VIP_ShowMenu(client);
			return;
		}
		
		g_bAutoRespawn[client] = !g_bAutoRespawn[client];
		
		if (bAccessByFlag || VIP_GetFlags(client) & VCF_VIP)
		{
			new Handle:kv = VIP_GetClientCache(client);
			if (kv)
			{
				KvSetString(kv, ITEM_NAME_AUTORESPAWN, g_bAutoRespawn[client] ? "1" : "");
				VIP_SaveClientCache(client, false);
			}
		}
		
		MyPanel(client);
	}
	else if (item == 8)
	{
		PLAY_EXIT_BACK_SOUND(client);
		VIP_ShowMenu(client);
	}
	else
		PLAY_EXIT_SOUND(client);
}

public event_respawn(Handle:event, const String:name[], bool:silent)
	wS_TryAutoReSpawn(GetClientOfUserId(GetEventInt(event, "userid")));

public Action:RespawnCmd(client, args)
{
	if (client < 1 || IsPlayerAlive(client) || GetClientTeam(client) < 2)
		return Plugin_Handled;

	if (!g_bAccess[client])
	{
		PrintToChat(client, "%t", "NoAccess");
		return Plugin_Handled;
	}

	if (!RespawnOn())
	{
		PrintToChat(client, "%t", "NoRespTime");
		return Plugin_Handled;
	}

	new count = 0;
	if (GetTrieValue(g_hTrie, g_sKey[client], count) && count >= g_bAccess[client])
	{
		PrintToChat(client, "%t", "NextRound");
		return Plugin_Handled;
	}

	SetTrieValue(g_hTrie, g_sKey[client], ++count, true);
	CS_RespawnPlayer(client);

	return Plugin_Handled;
}

public Action:g_hTimer_CallBack(Handle:timer, any:client)
{
	g_hTimer[client] = INVALID_HANDLE;
	if (RespawnOn() && IsClientInGame(client) && !IsPlayerAlive(client) && GetClientTeam(client) > 1)
	{
		decl count;
		if (!GetTrieValue(g_hTrie, g_sKey[client], count)) count = 0;
		SetTrieValue(g_hTrie, g_sKey[client], ++count, true);
		CS_RespawnPlayer(client);
	}
	return Plugin_Stop;
}

stock wS_TryAutoReSpawn(client, bool:bCheck = false)
{
	if (g_bAutoRespawn[client] && g_bAccess[client] && RespawnOn() && RespawnsLeft(client) && (!bCheck || (!IsPlayerAlive(client) && GetClientTeam(client) > 1)))
	{
		if (g_hTimer[client]) KillTimer(g_hTimer[client]);
		g_hTimer[client] = CreateTimer(3.0, g_hTimer_CallBack, client);
	}
}

stock RespawnsLeft(client) // сколько осталось возрождений в текущем раунде
{
	decl x;
	if (!GetTrieValue(g_hTrie, g_sKey[client], x)) x = 0;
	x = g_bAccess[client] - x;
	if (x < 0) x = 0;
	return x;
}

///

public round_start(Handle:event, const String:name[], bool:silent)
{
	ClearTrie(g_hTrie);

	new sec = GetConVarInt(g_hCvarRespawnTime);
	if (sec > 0)
	{
		sec = GetEventInt(event, "timelimit") - sec;
		if (sec > 0)
		{
			g_RespawnStopTimestamp = sec + GetTime();
			return;
		}
	}

	g_RespawnStopTimestamp = -1;
}

public round_end(Handle:event, const String:name[], bool:silent)
	g_RespawnStopTimestamp = GetTime();

stock bool:RespawnOn()
	return g_RespawnStopTimestamp < 1 || GetTime() < g_RespawnStopTimestamp;

stock wS_KillTimer(&Handle:t)
{
	if (t != INVALID_HANDLE)
	{
		KillTimer(t);
		t = INVALID_HANDLE;
	}
}
	
stock ClearAccessVars(client)
{
	g_bAccess[client] = 0;
	g_bAutoRespawn[client] = false;
	wS_KillTimer(g_hTimer[client]);
}

public OnClientDisconnect(client)
{
	g_sKey[client][0] = 0;
	ClearAccessVars(client);
}